setGeneric("colSums",
               function(x, na.rm=FALSE, dims=1)
               standardGeneric("colSums"))

setMethod("colSums",
          signature(x="externalVectorWithStorage",
                    na.rm="missing",
                    dims = "missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=1)
      })

setMethod("colSums",
          signature(x="externalVectorWithStorage",
                    na.rm="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=dims)
      })

setMethod("colSums",
          signature(x="externalVectorWithStorage",
                    dims="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=na.rm, dims=1)
      })

setMethod("colSums",
          signature(x="externalVectorWithStorage",
                    na.rm="logical",
                    dims="numeric"),
          function(x, na.rm, dims)
      {
          if (length(dn <- dim(x)) < 2)
              stop("`x' must be an external array of at least two dimensions")
          if (dims < 1 || dims > length(dn) - 1)
              stop("invalid `dims'")
          n <- prod(dn[1:dims])
          dn <- dn[-(1:dims)]
          x <- .Call("colSums", x, getNativeStorageMethods(x),
                     n, prod(dn), na.rm,
                     PACKAGE="externalVector")
          if (length(dn) > 1) {
              dim(x) <- dn
              dimnames(x) <- dimnames(x)[-(1:dims)]
          } else names(x) <- dimnames(x)[[dims + 1]]
          x
      })

setGeneric("colMeans",
               function(x, na.rm, dims)
               standardGeneric("colMeans"))

setMethod("colMeans",
          signature(x="externalVectorWithStorage",
                    na.rm="missing",
                    dims = "missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=1)
      })

setMethod("colMeans",
          signature(x="externalVectorWithStorage",
                    na.rm="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=dims)
      })

setMethod("colMeans",
          signature(x="externalVectorWithStorage",
                    dims="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=na.rm, dims=1)
      })

setMethod("colMeans",
          signature(x="externalVectorWithStorage",
                    na.rm="logical",
                    dims="numeric"),
          function(x, na.rm, dims)
      {
          if (length(dn <- dim(x)) < 2)
              stop("`x' must be an external array of at least two dimensions")
          if (dims < 1 || dims > length(dn) - 1)
              stop("invalid `dims'")
          n <- prod(dn[1:dims])
          dn <- dn[-(1:dims)]
          x <- .Call("colMeans", x, getNativeStorageMethods(x),
                     n, prod(dn), na.rm,
                     PACKAGE="externalVector")
          if (length(dn) > 1) {
              dim(x) <- dn
              dimnames(x) <- dimnames(x)[-(1:dims)]
          } else names(x) <- dimnames(x)[[dims + 1]]
          x
      })

setGeneric("rowSums",
               function(x, na.rm, dims)
               standardGeneric("rowSums"))

setMethod("rowSums",
          signature(x="externalVectorWithStorage",
                    na.rm="missing",
                    dims = "missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=1)
      })

setMethod("rowSums",
          signature(x="externalVectorWithStorage",
                    na.rm="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=dims)
      })

setMethod("rowSums",
          signature(x="externalVectorWithStorage",
                    dims="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=na.rm, dims=1)
      })

setMethod("rowSums",
          signature(x="externalVectorWithStorage",
                    na.rm="logical",
                    dims="numeric"),
          function(x, na.rm, dims)
      {
          if (length(dn <- dim(x)) < 2)
              stop("`x' must be an external array of at least two dimensions")
          if (dims < 1 || dims > length(dn) - 1)
              stop("invalid `dims'")
          p <- prod(dn[-(1:dims)])
          dn <- dn[1:dims]
          x <- .Call("rowSums", x, getNativeStorageMethods(x),
                     prod(dn), p, na.rm,
                     PACKAGE="externalVector")
          if (length(dn) > 1) {
              dim(x) <- dn
              dimnames(x) <- dimnames(x)[1:dims]
          } else names(x) <- dimnames(x)[[1]]
          x
      })

setGeneric("rowMeans",
               function(x, na.rm, dims)
               standardGeneric("rowMeans"))

setMethod("rowMeans",
          signature(x="externalVectorWithStorage",
                    na.rm="missing",
                    dims = "missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=1)
      })

setMethod("rowMeans",
          signature(x="externalVectorWithStorage",
                    na.rm="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=dims)
      })

setMethod("rowMeans",
          signature(x="externalVectorWithStorage",
                    dims="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=na.rm, dims=1)
      })

setMethod("rowMeans",
          signature(x="externalVectorWithStorage",
                    na.rm="logical",
                    dims="numeric"),
          function(x, na.rm, dims)
      {
          if (length(dn <- dim(x)) < 2)
              stop("`x' must be an external array of at least two dimensions")
          if (dims < 1 || dims > length(dn) - 1)
              stop("invalid `dims'")
          p <- prod(dn[-(1:dims)])
          dn <- dn[1:dims]
          x <- .Call("rowMeans", x, getNativeStorageMethods(x),
                     prod(dn), p, na.rm,
                     PACKAGE="externalVector")
          if (length(dn) > 1) {
              dim(x) <- dn
              dimnames(x) <- dimnames(x)[1:dims]
          } else names(x) <- dimnames(x)[[1]]
          x
      })

setMethod("apply",
          signature(X="externalVector"),
          function (X, MARGIN, FUN, ...)
      {
          FUN <- match.fun(FUN)

          ## Ensure that X is an array object
          d <- dim(X)
          dl <- length(d)
          if(dl == 0)
              stop("dim(X) must have a positive length")
          if (dl != 2)
              stop("can only handle external matrix objects in apply")
          ds <- 1:dl
          dn <- dimnames(X)

          ## Extract the margins and associated dimnames

          s.call <- ds[-MARGIN]
          s.ans  <- ds[MARGIN]
          d.call <- d[-MARGIN]
          d.ans  <- d[MARGIN]
          dn.call<- dn[-MARGIN]
          dn.ans <- dn[MARGIN]

          ## do the calls

          d2 <- prod(d.ans)
          if(d2 == 0) {
              ## arrays with some 0 extents: return ``empty result'' trying
              ## to use proper mode and dimension:
              ## The following is still a bit `hackish': use non-empty X
              newX <- array(vector(typeof(defaultElement(X)), 1), dim = c(prod(d.call), 1))
              ans <- FUN(if(length(d.call) < 2) newX[,1] else
                         array(newX[,1], d.call, dn.call), ...)
              return(if(is.null(ans)) ans else if(length(d.call) < 2) ans[1][-1]
              else array(ans, d.ans, dn.ans))
          }
          d1 <- prod(d.call)
          if (d1 == 0) {
              newX <- vector(typeof(defaultElement(X)), 0)
              ans <- FUN(if(length(d.call) < 2) newX else
                         array(newX, d.call, dn.call), ...)
              return(if(is.null(ans)) ans
              else array(ans, d.ans, dn.ans))
          }
          ans <- vector("list", d2)
          if (MARGIN == 2) {
              if(length(d.call) < 2) {# vector
                  for(i in 1:d2) ans[[i]] <- FUN(X[,i,drop=TRUE], ...)
              } else
              for(i in 1:d2) ans[[i]] <- FUN(array(X[,i,drop=TRUE], d.call, dn.call), ...)
          } else {
              if(length(d.call) < 2) {# vector
                  for(i in 1:d2) ans[[i]] <- FUN(X[i,,drop=TRUE], ...)
              } else
              for(i in 1:d2) ans[[i]] <- FUN(array(X[i,,drop=TRUE], d.call, dn.call), ...)
          }
          ## answer dims and dimnames

          ans.list <- is.recursive(ans[[1]])
          l.ans <- length(ans[[1]])

          ans.names <- names(ans[[1]])
          if(!ans.list)
              ans.list <- any(unlist(lapply(ans, length)) != l.ans)
          if(!ans.list && length(ans.names)) {
              all.same <- sapply(ans, function(x) identical(names(x), ans.names))
              if (!all(all.same)) ans.names <- NULL
          }
          len.a <- if(ans.list) d2 else length(ans <- unlist(ans, recursive = FALSE))
          if(length(MARGIN) == 1 && len.a == d2) {
              names(ans) <- if(length(dn.ans[[1]])) dn.ans[[1]] # else NULL
              return(ans)
          }
          if(len.a == d2)
              return(array(ans, d.ans, dn.ans))
          if(len.a > 0 && len.a %% d2 == 0)
              return(array(ans, c(len.a %/% d2, d.ans),
                           if(is.null(dn.ans)) {
                               if(!is.null(ans.names)) list(ans.names,NULL)
                           } else c(list(ans.names), dn.ans)))
          return(ans)
      })

setMethod("log",
          signature(x="externalVectorWithStorage", base="missing"),
          function (x, base)
      {
          klass <- class(defaultElement(x))
          if (!(klass %in% c("logical", "integer", "numeric",
                             "complex")))
              stop("Non-numeric argument to mathematical function")
          if (length(x) == 0)
              return(numeric(0))
          ans <- rebind(x,
                        type = if (klass == "complex") {
                            complex(1)
                        } else numeric(1))
          .Call("externalVectorMath", "log",
                x, getNativeStorageMethods(x@storage),
                ans, getNativeStorageMethods(ans@storage),
                PACKAGE="externalVector")
      })

setMethod("log",
          signature(x="externalVectorWithStorage",
                    base="externalVectorWithStorage"),
          function (x, base)
      {
          klass <- class(defaultElement(x))
          if (!(klass %in% c("logical", "integer", "numeric",
                             "complex")))
              stop("Non-numeric argument to mathematical function")
          if (length(base) == 0)
              stop("illegal 2nd arg of length 0")
          if (length(x) == 0)
              return(numeric(0))
          klass <- class(defaultElement(base))
          if (!(klass %in% c("logical", "integer", "numeric",
                             "complex")))
              stop("Non-numeric argument to mathematical function")
          ans <- .Call('externalVectorLog', x,
                       base,
                       PACKAGE="externalVector")
          n <- length(x)
          x@storage <- ans
          if (length(base) > n) {
              dim(x) <- dim(base)
              dimnames(x) <- dimnames(base)
              names(x) <- names(base)
          }
          x
      })

setMethod("log",
          signature(x="externalVectorWithStorage"),
          function (x, base)
      {
          klass <- class(defaultElement(x))
          if (!(klass %in% c("logical", "integer", "numeric",
                             "complex")))
              stop("Non-numeric argument to mathematical function")
          if (length(base) == 0)
              stop("illegal 2nd arg of length 0")
          if (length(x) == 0)
              return(numeric(0))
          klass <- class(base)
          if (!(klass %in% c("logical", "integer", "numeric",
                             "complex")))
              stop("Non-numeric argument to mathematical function")
          ans <- .Call('externalVectorLog', x,
                       base,
                       PACKAGE="externalVector")
          n <- ans@length
          if (length(x) == n) {
              x@storage <- ans
              x
          } else {
              base@storage <- ans
              base
          }
      })

setMethod("lapply",
          signature(X="externalVector"),
          function (X, FUN, ...)
      {
          X <- force(X)
          callNextMethod()
      })

setMethod("lapply",
          signature(X="externalVectorWithStorage"),
          function (X, FUN, ...)
      {
          FUN <- match.fun(FUN)
          mcall <- match.call()
          mcall$FUN <- NULL
          mcall[[1]] <- FUN
          names(mcall)[which(names(mcall) == "X")] <- ""
          rval <- .Call("externalVector_lapply",
                        X, length(X), mcall, parent.frame(),
                        PACKAGE="externalVector")
          names(rval) <- names(X)
          return(rval)
      })

setMethod("sapply",
          signature(X="externalVector"),
          function (X, FUN, ..., simplify, USE.NAMES)
      {
          FUN <- match.fun(FUN)
          answer <- lapply(X, FUN, ...)
          if (USE.NAMES && is.character(defaultElement(X)) &&
              is.null(names(answer)))
              names(answer) <- as.Rvector(X)
          if (simplify && length(answer) &&
              length(common.len <- unique(unlist(lapply(answer,
                                                        length)))) == 1) {
              if (common.len == 1)
                  unlist(answer, recursive = FALSE)
              else if (common.len > 1)
                  array(unlist(answer, recursive = FALSE),
                        dim = c(common.len, length(X)),
                        dimnames = if (!(is.null(n1 <- names(answer[[1]])) &
                                         is.null(n2 <- names(answer)))) {
                            list(n1, n2)
                        })
              else answer
          } else answer
      })

setMethod("mean",
          signature(x="externalVector"),
          function (x, trim = 0, na.rm = FALSE, ...)
          mean(as.Rvector(as.vector(x)), trim, na.rm, ...))

setMethod("median",
          signature(x="externalVector"),
          function (x, na.rm)
          median(as.Rvector(as.vector(x)), na.rm))

setMethod("median",
          signature(x="externalVector", na.rm="missing"),
          function (x, na.rm)
          median(as.Rvector(as.vector(x)), FALSE))

    var.default <- var

    setGeneric("var",
               function(x, y, na.rm = FALSE, use)
               standardGeneric("var"))

    setMethod("var",
              signature(y="missing"),
              function (x, y, na.rm, use)
          {
              if (missing(na.rm))
                  na.rm <- FALSE
              if (missing(use))
                  var(x, NULL, na.rm)
              else var(x, NULL, na.rm, use)
          })

    setMethod("var",
              signature(y="ANY"), var.default)

    rm(var.default)

setMethod("var",
          signature(x="externalVector"),
          function (x, y, na.rm, use)
      {
          x <- as.Rvector(x)
          callGeneric()
      })

setMethod("var",
          signature(y="externalVector"),
          function (x, y, na.rm, use)
      {
          y <- as.Rvector(y)
          callGeneric()
      })

    cov.default <- cov

    setGeneric("cov",
               function(x, y, use = "all.obs",
                        method = c("pearson",
                                   "kendall", "spearman"))
               standardGeneric("cov"))

    setMethod("cov",
              signature(y="missing"),
              function (x, y, use, method)
          {
              if (missing(use))
                  use <- "all.obs"
              if (missing(method))
                  method <- "pearson"
              else method <- match.arg(method,
                                       c("pearson",
                                         "kendall",
                                         "spearman"))
              cov(x, NULL, use, method)
          })

    setMethod("cov",
              signature(y="ANY"), cov.default)

    rm(cov.default)

setMethod("cov",
          signature(x="externalVector"),
          function (x, y, use, method)
      {
          x <- as.Rvector(x)
          callGeneric()
      })

setMethod("cov",
          signature(y="externalVector"),
          function (x, y, use, method)
      {
          y <- as.Rvector(y)
          callGeneric()
      })

    cor.default <- cor

    setGeneric("cor",
               function(x, y, use = "all.obs",
                        method = c("pearson",
                                   "kendall", "spearman"))
               standardGeneric("cor"))

    setMethod("cor",
              signature(y="missing"),
              function (x, y, use, method)
          {
              if (missing(use))
                  use <- "all.obs"
              if (missing(method))
                  method <- "pearson"
              else method <- match.arg(method,
                                       c("pearson",
                                         "kendall",
                                         "spearman"))
              cor(x, NULL, use, method)
          })

    setMethod("cor",
              signature(y="ANY"), cor.default)

    rm(cor.default)

setMethod("cor",
          signature(x="externalVector"),
          function (x, y, use, method)
      {
          x <- as.Rvector(x)
          callGeneric()
      })

setMethod("cor",
          signature(y="externalVector"),
          function (x, y, use, method)
      {
          y <- as.Rvector(y)
          callGeneric()
      })

setMethod("cov2cor",
          signature(V = "externalVector"),
          function (V)
          cov2cor(as.Rvector(V)))
