\name{SubscriptList}
\alias{SubscriptList}
\title{ Function to convert a list of array subscripts to a list objects
of class vectorIndex. }
\description{
  SubscriptList takes a list of subscripts to a subset or subassign
  operation and converts each subscript to an object belonging to the
  virtual class \code{vectorIndex}.
}
\usage{
SubscriptList(subs, length.object, dim.object = NULL, names.object = NULL, dimnames.object = NULL, assign.operation = FALSE)
}
\arguments{
  \item{subs}{ An object of class "list", elements are valid
    subscripts. }
  \item{length.object}{ A scalar of class "integer", representing the
    length of the object being subsetted or subassigned. }
  \item{dim.object}{ An object of class "integer" or \code{NULL}, the
    dimension of the object. }
  \item{names.object}{ An object belonging to class union
    "validNamesClass", the names of the object viewed as a vector. }
  \item{dimnames.object}{ \code{NULL} or an object of class "list", each
    of whose elements are objects belonging to class union "validNamesClass". }
  \item{assign.operation}{ A scalar of class "logical", if \code{TRUE}
    the subscripts are for a subasign operation, if \code{FALSE},
    the subscripts are for a subset operation. }
}
\value{
  An object of class "list" of same length as \code{subs} with each
  element a 
}
\author{ Saikat DebRoy \email{<saikat@stat.wisc.edu>} }
\seealso{
  See class union \code{\link{vectorNamesType-class}} for possible
  subscripts which are matched against the \code{names.object} or elements of
  \code{dimnames.object}.

  Also see class union \code{\link{vectorIndex-class}} for some other
  possible subscripts and for all possible elements in the returned
  list.

  Finally, see \code{\link{[}} for other subscripts that are valid.
}
\examples{
subs <- alist(i= , j= )
subs$j <- 1:4
SubscriptList(subs, 15, c(3, 5))
SubscriptList(list(i=c("a", "c"), j=-2), 15, c(3, 5),
              dimnames=list(letters[1:3], LETTERS[1:5]))
}
\keyword{array}
\keyword{list}
