\name{as.Rvector}
\alias{as.Rvector}
\alias{as.Rmatrix}
\alias{as.Rvector,array-method}
\alias{as.Rvector,matrix-method}
\alias{as.Rvector,logical-method}
\alias{as.Rvector,integer-method}
\alias{as.Rvector,numeric-method}
\alias{as.Rvector,complex-method}
\alias{as.Rvector,character-method}
\alias{as.Rvector,list-method}
\alias{as.Rmatrix,matrix-method}
\alias{as.Rmatrix,ANY-method}
\title{ convert an object to an R basic vector or matrix}
\description{
  \code{as.Rvector}, a generic, attempts to coerce its argument into a
  basic R vector of a convenient mode. All attributes of \code{x} are
  preserved.
  
  Default methods are provided for basic R objects which are returned
  unchanged by as.Rvector.
  
  \code{as.Rmatrix}, a generic, first converts its argument to a basic R
  vector and then applies as.matrix to the result.
}
\usage{
as.Rvector(x)
as.Rmatrix(x)
}
\arguments{
  \item{x}{ An object }
}
\details{
  This preserves all the non-slot attributes of the object \code{x}
  when converting to a basic R vector. In addition, if any of
  \code{dim(x)}, \code{dimnames(x)}, \code{names(x)} is not
  \code{NULL}, the corresponding attribute in the result is also set.
}
\value{
  The value from as.Rvector is a basic R vector of mode "logical", "integer",
  "numeric", "complex", "character" or "list".
  The value from as.Rmatrix is a basic R matrix.
}
\seealso{ \code{\link{as.vector}} for converting an object to an
  appropriate vector with all attributes removed and
  \code{\link{as.matrix}} for converting a vector like object to a
  matrix.}
\examples{
x <- 1:2
names(x) <- letters[1:2]
as.vector(x)
as.Rvector(x)
as.Rmatrix(x)
}
\keyword{classes}
