\name{nativeStorageMethodsList-class}
\docType{class}
\alias{nativeStorageMethodsList-class}
\alias{initialize,nativeStorageMethodsList-method}

\title{Class "nativeStorageMethodsList", contains objects from class
  "nativeStorageMethods"}
\description{ The class \code{"nativeStorageMethodsList"} contains a
  number of slots, all from class
  \code{"nativeStorageMethods"}. Usually, each object of class
  \code{"nativeStorageMethodsList"} is associated with a particular
  subclass of \code{"externalSTorage"}.
  
  Objects from this class are never visible to the user.}
\section{Objects from the Class}{
  Objects can be created by calls of the form
  \code{new("nativeStorageMethodsList")}. Any extra arguments are ignored.
}
\section{Slots}{
  All slots in this class are objects of class \code{"nativeStorageMethods"}.
  \describe{
    \item{\code{allMethods}:}{ Contains the C \code{storageMethods}
      structure with all methods registered (directly or indirectly) for
      the associated \code{"externalStorage"} class. }
    \item{\code{logicalMethods}:}{ Object returned by
      \code{getExternalStorageMethods} for the associated
      \code{"externalStorage"} class and type \code{"logical"}. }
    \item{\code{integerMethods}:}{ Object returned by
      \code{getExternalStorageMethods} for the associated
      \code{"externalStorage"} class and type \code{"integer"}. }
    \item{\code{numericMethods}:}{ Object returned by
      \code{getExternalStorageMethods} for the associated
      \code{"externalStorage"} class and type \code{"numeric"}. }
    \item{\code{complexMethods}:}{ Object returned by
      \code{getExternalStorageMethods} for the associated
      \code{"externalStorage"} class and type \code{"complex"}. }
    \item{\code{characterMethods}:}{ Object returned by
      \code{getExternalStorageMethods} for the associated
      \code{"externalStorage"} class and type \code{"character"}. }
    \item{\code{listMethods}:}{ Object returned by
      \code{getExternalStorageMethods} for the associated
      \code{"externalStorage"} class and type \code{"list"}. }
  }
}
\section{Methods}{
  \describe{
    \item{initialize(.Object, \dots)}{ Initializer method for class
      \code{"nativeStorageMethodsList"}. This initializes each of the
      slots of the class. Any extra argument in \code{\dots} is
      ignored. }
  }
}
\keyword{classes}
