\name{rebind}
\alias{rebind}
\title{ Allocate a new external vector with external storage }
\description{
  This function allocates a new "externalVectorWithStorage" object with
  possibly new length, type, names, dimension or dimnames.
}
\usage{
rebind(x, length.x = length(x), type = x@storage@type,
       names.x = x@Names, dim.x = x@Dim,
       dimnames.x = x@DimNames, \dots, arrayOnly = FALSE)
}
\arguments{
  \item{x}{ An object of class "externalVectorWithStorage". }
  \item{length.x}{ New length. }
  \item{type}{ New type. }
  \item{names.x}{ New names. }
  \item{dim.x}{ New dimension. }
  \item{dimnames.x}{ New dimnames. }
  \item{\dots}{Other arguments passed to initializer of the class of
    \code{x}.}
  \item{arrayOnly}{ Just create the data part with no names, dimensions
    or dimnames. }
}
\value{
  A new object of same class as \code{x}.
}
\seealso{ \code{\link{externalVectorWithStorage-class}} }
\keyword{classes}
