#include "storageMethods.h"

#define FIND_SET_ELT_INTERNAL(setName, setElt, methods, mode, msg) \
    { \
        const char* __msg__ = (msg); \
        storageMethods_t* __methods__ = (methods); \
        switch((mode)) {                        \
        case LGLSXP:                            \
            (setElt) = __methods__->logical##setName;    \
            break;                              \
        case INTSXP:                            \
            (setElt) = __methods__->integer##setName;    \
            break;                              \
        case REALSXP:                            \
            (setElt) = __methods__->numeric##setName;    \
            break;                              \
        case CPLXSXP:                            \
            (setElt) = __methods__->complex##setName;    \
            break;                              \
        case STRSXP:                            \
            (setElt) = __methods__->character##setName;    \
            break;                              \
        case VECSXP: \
            if (__msg__ == NULL) \
                __msg__ = "assignment to external vectors with arbitrary element type is not supported"; \
        default:                                \
            if (__msg__ == NULL) \
                __msg__ = "no setElt method for this mode"; \
            error(__msg__);   \
            (setElt) = __methods__->character##setName; /* -Wall */ \
        } \
    }

#define FIND_SET_ELT(setElt, methods, mode, msg) \
    FIND_SET_ELT_INTERNAL(SetElt, setElt, methods, mode, msg)

#define FIND_SETMAT_ELT(setElt, methods, mode, msg) \
    FIND_SET_ELT_INTERNAL(SetMatrixElt, setElt, methods, mode, msg)

